<template>
  <GenericLayout>
    <template #header>
      <Header
        back-button
        :title="pageTitle"
        :badge-content="pageSubTitle"
      />
    </template>

    <template #page-content>
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
        <div
          class="page-subtitle"
          v-if="pageSubTitle"
        >
          {{ pageSubTitle }}
        </div>
      </template>

      <template v-if="loading">
        <div
          class="column flex-center"
        >
          <q-spinner-dots
            color="primary"
            size="40px"
          />
        </div>
      </template>

      <template v-else-if="agriPlot">
        <PlotEditForm
          v-if="!creationInProgress"
          @on-save="onSave"
          @on-cancel="onCancel"
        />

        <template v-else>
          <div class="column flex-center text-grey">
            <h6 class="text-weight-regular">
              <translate>Plot creation in progress</translate>
            </h6>
            <q-spinner-dots
              color="primary"
              size="40px"
            />
          </div>
        </template>
      </template>

      <template v-else>
        <q-card :square="!isDesktopPlatform">
          <q-card-section>
            <span class="text-subtitle1 text-dark">
              <translate>No agricultural data found</translate>
            </span>
          </q-card-section>
        </q-card>
      </template>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import PlotEditForm from 'src/pages/holding-campaign/plot/components/PlotEditForm'
import queryHoldingCampaignByPk from 'src/pages/holding-campaign/plot/graphql/queryHoldingCampaignByPk'
import mutationInsertPlot from 'src/pages/holding-campaign/plot/graphql/mutationInsertPlot'
import queryAgriPlotByPk from 'src/pages/holding-campaign/plot/graphql/queryAgriPlotByPk'
import queryPlotByPk from 'src/pages/holding-campaign/plot/graphql/queryPlotByPk'

export default {
  name: 'PlotCreationPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    PlotEditForm
  },
  data () {
    return {
      agriPlot: null,
      createdPlotId: null,
      creationInProgress: false
    }
  },
  computed: {
    pageTitle () {
      return this.plotName
    },
    pageSubTitle () {
      return this.$store.state.fastplatform.holdingCampaign.campaign.name
    },
    loading () {
      return !this.agriPlot && this.$apollo.queries.agriPlot.loading
    },
    plotName () {
      return this.$gettext('Add a plot')
    },
    agriPlotId () {
      return this.$route.params.agriPlotId
    }
  },
  apollo: {
    holdingCampaign: {
      query: queryHoldingCampaignByPk,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          holding_campaign_id: this.$store.state.fastplatform.holdingCampaign.id
        }
      }
    },
    agriPlot: {
      query: queryAgriPlotByPk,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          agriPlotId: this.agriPlotId
        }
      },
      update: data => data.external__agri_plot_by_pk
    },
    createdPlot: {
      query: queryPlotByPk,
      variables () {
        return {
          plotId: this.createdPlotId
        }
      },
      skip () {
        return !this.createdPlotId
      },
      update: data => data.plot,
      result ({ data }) {
        const plot = data?.plot
        if (plot) {
          this.$q.notify({
            message: this.$gettext('The plot was sucessfully added to the current campaign.'),
            color: 'green'
          })
          this.$router.replace({ name: 'plot', params: { idPlot: plot.id } })
        }
      },
      fetchPolicy: 'network-only'
    }
  },
  methods: {
    onSave (name) {
      this.creationInProgress = true
      this.$apollo.mutate({
        mutation: mutationInsertPlot,
        variables: {
          name,
          site_id: this.holdingCampaign.sites?.[0]?.id,
          authority_id: this.agriPlot.authority_id,
          geometry: this.agriPlot.geometry
        }
      }).then(({ data: { insertedPlot } }) => {
        // when plot is inserted we must wait for properties created by triggers (such as bbox and thumbmail)
        this.createdPlotId = insertedPlot.id
      }).catch(e => {
        console.error('Could not create plot', e)
        this.$q.notify({
          message: this.$gettext('There was an error while adding the plot to current campaign.'),
          color: 'red'
        })
        this.creationInProgress = false
      })
    },
    onCancel () {
      this.$router.back()
    }
  }
}
</script>
